/*****************************************************************************/
// MainWindow
// Written by Hartmut Reh
//
// MainWindow.h
//
//
// Copyright (c) 2004 OpenBeOS Project
//
// MainWindow.h
// Generated by Interface Elements (Window v2.3) on Apr 11 2004
// This is a user written class and will not be overwritten.
//
/*****************************************************************************/

#ifndef _MAINWINDOW_H_
#define _MAINWINDOW_H_

#include "IEWindow.h"
#include "MainWindowDefs.h"
#include "TheUSBRoster.h"
#include "TPreferences.h"


class MainWindow : public IEWindow
{
	public:
									MainWindow(void);
									~MainWindow(void);

		virtual void 	MessageReceived(BMessage *message);
		virtual bool 	QuitRequested();
						void	InitInterface(void);
						bool	ThreadRunning(void);
						void  WriteModeBoxLabel(const char *label);
						void 	EnableAllElements(bool enable);
						void	WriteDisplay(uint16 data);						
						void	ClearDisplay(void);
	
	private:	
    TheUSBRoster	*fTheRoster;
		BList			 		fDevList;
		bool					fReceiving;
		
		int32					fVendorID;
		int32					fProductID;
		char					fSerialNumber[10];
		
		BView					*fMainView;
		BBox					*fUSBDeviceBox;
		BTextControl	*fVendorIDControl;
		BTextControl	*fProductIDControl;
		BTextControl	*fSerialNumberControl;
		BButton				*fSearchButton;
		BBox					*fDeviceBox;
		BStringView		*fDeviceString;
		BBox					*fModeBox;
		BButton				*fStartButton;
		BPictureButton	*fInOutButton;
		BCheckBox			*fReadImmediate;
		
		TPreferences	*fPrefs;
		BRect					fWindFrame;
		void					GetPrefs(void);
		void					SetPrefs(void);
		
		BCheckBox			*fSP0[8];				// Set Port 0
		BCheckBox			*fSP1[8];				// Set Port 1
		
		BPictureButton	*fRP0[8];			// Read Port 0
		BPictureButton	*fRP1[8];			// Read Port 0
		
		BStringView			*fRedText1;
		BStringView			*fRedText2;

};

#endif
